"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var PostgresCoreModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.PostgresCoreModule = void 0;
const common_1 = require("@nestjs/common");
const pg_1 = require("pg");
const postgres_constants_1 = require("./postgres.constants");
const POSTGRES_DB_CONNECTION = postgres_constants_1.constants.pg_connection;
let PostgresCoreModule = PostgresCoreModule_1 = class PostgresCoreModule {
    constructor(pool) {
        this.pool = pool;
    }
    static forRoot(options) {
        const poolProvider = {
            provide: POSTGRES_DB_CONNECTION,
            useFactory: () => new pg_1.Pool(options),
        };
        return {
            module: PostgresCoreModule_1,
            providers: [poolProvider],
            exports: [poolProvider],
        };
    }
    static forRootAsync(options) {
        const poolProvider = {
            provide: POSTGRES_DB_CONNECTION,
            useFactory: (...args) => __awaiter(this, void 0, void 0, function* () {
                const poolConfig = yield options.useFactory(...args);
                return new pg_1.Pool(poolConfig);
            }),
            inject: options.inject || [],
        };
        return {
            module: PostgresCoreModule_1,
            providers: [poolProvider],
            exports: [poolProvider],
        };
    }
    static forFeature(sqlStatement) {
        const createTableIfNotExists = {
            provide: 'CREATE_TABLE_IF_NOT_EXISTS',
            useFactory: (pool) => __awaiter(this, void 0, void 0, function* () {
                const client = yield pool.connect();
                try {
                    const res = yield client.query(sqlStatement);
                    // console.log('queryResult: ', res);
                }
                catch (error) {
                    console.log('postgres statement error:', error);
                }
                finally {
                    client.release();
                }
            }),
            inject: [{ token: POSTGRES_DB_CONNECTION, optional: false }],
        };
        return {
            module: PostgresCoreModule_1,
            providers: [createTableIfNotExists],
        };
        // Get pg connection and run sql statement on it
    }
};
PostgresCoreModule = PostgresCoreModule_1 = __decorate([
    (0, common_1.Global)(),
    (0, common_1.Module)({}),
    __param(0, (0, common_1.Inject)(POSTGRES_DB_CONNECTION))
], PostgresCoreModule);
exports.PostgresCoreModule = PostgresCoreModule;
