var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var PostgresCoreModule_1;
import { Module, Inject, Global } from '@nestjs/common';
import { Pool } from 'pg';
import { constants } from './postgres.constants';
const POSTGRES_DB_CONNECTION = constants.pg_connection;
let PostgresCoreModule = PostgresCoreModule_1 = class PostgresCoreModule {
    pool;
    constructor(pool) {
        this.pool = pool;
    }
    static forRoot(options) {
        const poolProvider = {
            provide: POSTGRES_DB_CONNECTION,
            useFactory: () => new Pool(options),
        };
        return {
            module: PostgresCoreModule_1,
            providers: [poolProvider],
            exports: [poolProvider],
        };
    }
    static forRootAsync(options) {
        const poolProvider = {
            provide: POSTGRES_DB_CONNECTION,
            useFactory: async (...args) => {
                const poolConfig = await options.useFactory(...args);
                return new Pool(poolConfig);
            },
            inject: options.inject || [],
        };
        return {
            module: PostgresCoreModule_1,
            providers: [poolProvider],
            exports: [poolProvider],
        };
    }
    static forFeature(sqlStatement) {
        const createTableIfNotExists = {
            provide: 'CREATE_TABLE_IF_NOT_EXISTS',
            useFactory: async (pool) => {
                const client = await pool.connect();
                try {
                    const res = await client.query(sqlStatement);
                    // console.log('queryResult: ', res);
                }
                catch (error) {
                    console.log('postgres statement error:', error);
                }
                finally {
                    client.release();
                }
            },
            inject: [{ token: POSTGRES_DB_CONNECTION, optional: false }],
        };
        return {
            module: PostgresCoreModule_1,
            providers: [createTableIfNotExists],
        };
        // Get pg connection and run sql statement on it
    }
};
PostgresCoreModule = PostgresCoreModule_1 = __decorate([
    Global(),
    Module({}),
    __param(0, Inject(POSTGRES_DB_CONNECTION))
], PostgresCoreModule);
export { PostgresCoreModule };
